#
#  Makefile for Waterloo TCP sample applications
#
#  OpenWatcom + WIN32 executables.
#
#  Usage: 'wmake -f ow_win.mak'
#

.EXTENSIONS:
.EXTENSIONS: .exe .obj .c

CC      = wcc386
CFLAGS  = -bt=nt -mf -w6 -d2 -zq -zc -zm -3s -I..\inc -fr=nul
WATTLIB = ..\lib\wattcpw_imp.lib

LINK   = wlink
LFLAGS = option quiet, map, eliminate, caseexact &
         system nt debug all sort global library $(WATTLIB)

PROGS = ping.exe     popdump.exe  rexec.exe   tcpinfo.exe  cookie.exe   &
        daytime.exe  dayserv.exe  finger.exe  host.exe     lpq.exe      &
        lpr.exe      ntime.exe    ph.exe      stat.exe     htget.exe    &
        revip.exe    vlsm.exe     whois.exe   wol.exe      eth-wake.exe &
        ident.exe    country.exe

$(PROGS): $(WATTLIB)

all:  $(PROGS)
      @echo Watcom/WIN32 binaries done

.c.exe:
      $(CC) $(CFLAGS) $*.c
      $(LINK) $(LFLAGS) name $*.exe file $*.obj

clean:
      @del *.obj
      @del *.map
      @del $(PROGS)

