#
#  Makefile for Waterloo TCP sample applications
#
#  Microsoft Visual-C / Win32 executables.
#

#
# Build using static library (1) wattcpvc.lib or use the watt-32.dll
# via the import library wattcpvc_imp.lib (0).
#
STATIC_LIB = 0

#
# Debug-mode or release-mode libraries are used. Make sure wattcp*.lib
# was compiled with the same configuration. If Watt-32 libs where built
# with "-M?d" and "-D_DEBUG" you should set DEBUG_MODE = 1.
#
# These configurations are possible:
#
#  Option Runtime      Thread-safe Debug/release
#  -------------------------------------------------
#  -MD    msvcrt.dll   Yes         release (normal)
#  -MDd   msvcrtd.dll  Yes         debug
#  -ML    libc.lib     No          release
#  -MLd   libcd.lib    No          debug
#  -MT    libcmt.lib   Yes         release
#  -MTd   libcmtd.lib  Yes         debug
#
# Build with DEBUG_MODE=1 if you want to prfile the program with
# .\vcprof.bat.
#
DEBUG_MODE = 1

CC     = cl
CFLAGS = -DWIN32 -nologo -W2 -Gy -I..\inc

!if $(DEBUG_MODE) == 1
DEBUG = _d
CFLAGS = $(CFLAGS) -MDd -Yd -Ge -GZ -Zi -Os -D_DEBUG
!else
DEBUG  =
CFLAGS = $(CFLAGS) -MD -Ot -Gs
!endif

!if $(STATIC_LIB) == 1
CFLAGS  = $(CFLAGS) -DWATT32_STATIC
WATTLIB = ..\lib\wattcpvc$(DEBUG).lib
LIBS    = $(WATTLIB) advapi32.lib user32.lib

!else
WATTLIB = ..\lib\wattcpvc_imp$(DEBUG).lib
LIBS    = $(WATTLIB)
!endif

PROGRAMS = popdump.exe rexec.exe   tcpinfo.exe cookie.exe \
           daytime.exe dayserv.exe finger.exe  host.exe   \
           lpq.exe     lpr.exe     ntime.exe   ph.exe     \
           stat.exe    htget.exe   revip.exe   vlsm.exe   \
           whois.exe   ping.exe    ident.exe   country.exe

all:  $(PROGRAMS)
      @echo Visual-C binaries done

$(PROGRAMS): $(WATTLIB)

.c.exe:
      $(CC) -c $(CFLAGS) $*.c
      link @<<
!if $(DEBUG_MODE) == 1
        -debug
!else
        -release
!endif
        -fixed:no -mapinfo:exports -machine:i386
        -map:$*.map -out:$*.exe $*.obj $(LIBS)
<<

clean:
      - @del *.exe
      - @del *.ilk
      - @del *.map
      - @del *.obj
      - @del *.pdb
      - @del *.pbo
      - @del *.pbt
      - @del *.pbi
      - @del *._xe

